#!/usr/bin/python
# _*_ coding:utf-8 _*_
import sys

import math
import threading

import time

from config import define_attr
from config import setting_crawer
import os
from publicfile.customizeClass import MyException
from publicfile.customizeModel import MyDB


def checkoutPath():

    if not os.path.exists(setting_crawer.ACCOUNT_PATH):
        raise MyException('你没有亚马逊用户信息哦！快去弄好,放在./config里面,并且命名为amazon_account.csv')


    if not os.path.exists(setting_crawer.EVENTS_PATH):
        raise MyException('你没有下载好财务信息哦！快去运行python finances_groupid.py')

    if not os.path.exists(setting_crawer.ORDER_PATH):
        raise MyException('你没有下载好订单信息！快去运行python finances_order.py')

try:
    checkoutPath()
except Exception,e:
    print e
    sys.exit()

mydb = MyDB()
with open(setting_crawer.ACCOUNT_PATH) as account_list:
    account_line = account_list.readline().replace('\n','').split(',')
    account_line = account_list.readline().replace('\n','').split(',')

    '''
            account_line[1] 店铺名
        '''
    while len(account_line) > 1:
        if define_attr.crawer_account and account_line[2] not in define_attr.crawer_account:
            account_line = account_list.readline().replace('\n', '').split(',')
            continue
        elif account_line[2] in define_attr.no_crawer_account:
            account_line = account_list.readline().replace('\n', '').split(',')
            continue

        with open(setting_crawer.ORDER_PATH + account_line[1] + '.csv', 'r') as order_file:
            order_dict = {}
            order_list = []
            line_list = order_file.readline().split('\t')
            line_list = order_file.readline().replace('\n', '').split('\t')

            while len(line_list) > 1:
                order_dict[unicode(str(line_list[3]), "utf8")] = line_list
                line_list = order_file.readline().replace('\n', '').split('\t')

        with open(setting_crawer.EVENTS_PATH + account_line[1] + '.csv', 'r') as event_file:
            db_num = 1
            event_dict = {}
            line_list = event_file.readline().split('\t')
            line_list = event_file.readline().replace('\n', '').split('\t')
            fba_sql = 'insert into finance.finance_amazon_fba_crawer (%s) values' % mydb.get_finance_amazon_fba_fields()
            sandan_sql = 'insert into finance.finance_amazon_sandan_crawer (%s) values' % mydb.get_finance_amazon_fba_fields()

            while len(line_list) > 1:
                marketplace_filter = define_attr.region.get(account_line[5], 'US').lower()
                if marketplace_filter == 'us':
                    marketplace_filter = 'com'
                if marketplace_filter not in line_list[8]:
                    line_list = event_file.readline().replace('\n', '').split('\t')
                    continue
                order_line = order_dict.get(line_list[4],['','','','','','','',''])
                while len(order_line) < 8:
                    order_line.append('')
                if len(order_line) > 8:
                    order_line = order_line[:8]
                if 'Seller' == order_line[4]:
                    database_name = 'finance_amazon_sandan_crawer'
                else:
                    database_name = 'finance_amazon_fba_crawer'

                results = ''
                if 'Seller' == order_line[4]:
                    sandan_sql += '(%s),' % \
                                  ('"' + line_list[0] + '","' + line_list[2] + '","' + '","'.join(
                                      line_list[4:9]) + '","' + '","'.join(line_list[10:20]) + '","' + account_line[
                                       1] + '","' + '","'.join(order_line[4:8]) + '"')
                else:
                    fba_sql += '(%s),' % \
                               ('"' + line_list[0] + '","' + line_list[2] + '","' + '","'.join(
                                   line_list[4:9]) + '","' + '","'.join(line_list[10:20]) + '","' + account_line[
                                    1] + '","' + '","'.join(order_line[4:8]) + '"')

                print '正在拼装SQL-->%s-----------%d条' % (account_line[1], db_num)
                db_num += 1
                line_list = event_file.readline().replace('\n', '').split('\t')

            print account_line[1] + '-->SQL:--------------->%s' % fba_sql[:-1]
            mydb.do_line(fba_sql[:-1])
            print account_line[1] + 'SQL:--------------->%s' % sandan_sql[:-1]
            mydb.do_line(sandan_sql[:-1])
            print account_line[1] + '正在存入数据库-->%s-----------%d条' % (account_line[1], db_num)

        account_line = account_list.readline().replace('\n', '').split(',')

