#!/usr/bin/python
# _*_ coding:utf-8 _*_
import sys

import time

from config import define_attr
from config import setting_crawer
from mws import Amazon_Finance
import os
from publicfile.customizeClass import MyException
from publicfile.customizeFunction import get_data_to_save_db, csv_sort


def checkoutPath():

    if not os.path.exists(setting_crawer.ACCOUNT_PATH):
        raise MyException('你没有亚马逊用户信息哦！快去弄好,放在./config里面,并且命名为amazon_account.csv')

    if not os.path.exists(setting_crawer.GROUP_ID_PATH):
        os.mkdir(setting_crawer.GROUP_ID_PATH)

    if not os.path.exists(setting_crawer.EVENTS_PATH):
        os.mkdir(setting_crawer.EVENTS_PATH)

    if not os.path.exists(setting_crawer.ORDER_PATH):
        os.mkdir(setting_crawer.ORDER_PATH)

    if not os.path.exists(setting_crawer.XML_EVENTS_PATH):
        os.mkdir(setting_crawer.XML_EVENTS_PATH)

    if not os.path.exists(setting_crawer.XML_ORDER_PATH):
        os.mkdir(setting_crawer.XML_ORDER_PATH)



def checkouEventsFile(storename):
    with open(setting_crawer.EVENTS_PATH + storename + '.csv', 'w') as check_file:
        check_file.write('\t'.join(setting_crawer.EVENTS_CSV_FIELDS)+"\n")
    with open(setting_crawer.ORDER_PATH + storename + '.csv', 'w') as check_file:
        check_file.write('\t'.join(setting_crawer.ORDER_CSV_FIELDS)+"\n")

    if not os.path.exists(setting_crawer.XML_EVENTS_PATH + storename):
        os.mkdir(setting_crawer.XML_EVENTS_PATH + storename)

try:
    checkoutPath()
except Exception,e:
    print e
    sys.exit()


with open(setting_crawer.ACCOUNT_PATH) as account_list:
    account_line = account_list.readline().replace('\n','').split(',')
    account_line = account_list.readline().replace('\n','').split(',')
    '''
        account_line[1] 店铺名
    '''
    while len(account_line) > 1:
        if define_attr.crawer_account and account_line[1] not in define_attr.crawer_account:
            account_line = account_list.readline().replace('\n', '').split(',')
            continue
        elif account_line[1] in define_attr.no_crawer_account:
            account_line = account_list.readline().replace('\n', '').split(',')
            continue
        amazon_api = Amazon_Finance(access_key=account_line[2],
                                    secret_key=account_line[3],
                                    account_id=account_line[4],
                                    mws_auth_token=account_line[6],
                                    region=define_attr.region.get(account_line[5],'US'),
                                    mkplace_id=account_line[5],
                                   )
        retry_num = 1
        checkouEventsFile(account_line[1])
        with open(setting_crawer.GROUP_ID_PATH + account_line[1] + '.csv','a+') as group_id_file:
            with open(setting_crawer.EVENTS_PATH + account_line[1] + '.csv', 'a+') as event_file:
                with open(setting_crawer.ORDER_PATH + account_line[1] + '.csv', 'a+') as order_file:
                    group_id_list = group_id_file.readlines()
                    for group_id_line in group_id_list[1:]:
                        next_token_index = 1
                        next_token = 1
                        retry_num = 1
                        while retry_num <= 3:
                            try:
                                while next_token:
                                    if next_token_index == 1:
                                        event_dict = amazon_api.list_finace_event(group_id_line.replace('\n', ''))
                                    else:
                                        event_dict = amazon_api.list_finace_event_by_nextToken(next_token)
                                    with open(setting_crawer.XML_EVENTS_PATH + account_line[1] + '/' + group_id_line.replace('\n', '') + str(next_token_index) + '.xml', 'w') as xml_event_file:
                                        xml_event_file.write(event_dict.response.content)
                                    print ('%s---->正在跑的,别着急  %d次访问:  %s'%(account_line[1], retry_num, group_id_line))
                                    event_data = get_data_to_save_db(event_dict.parsed.get('FinancialEvents',{}),account_line[5],account_line[1])
                                    if event_data.get('fee_info',[]):
                                        event_file.write("\n".join(event_data.get('fee_info',[])) + '\n')
                                    if event_data.get('order_id_info', []):
                                        order_file.write("\n".join(event_data.get('order_id_info',[])) + '\n')
                                    next_token = event_dict.parsed.get('NextToken',{}).get('value','')
                                    retry_num = 1
                                    next_token_index += 1
                                break
                            except Exception,e:
                                print('%s---->访问API异常,正在重试第%d次  :  %s'%(account_line[1], retry_num, str(e)[:100]))
                                retry_num += 1
                        if retry_num > 3:
                            with open(setting_crawer.API_LOG_PATH + account_line[1] + '.txt', 'a+') as log_write:
                                log_write.write('%20s : %s' % (time.strftime('%Y-%m-%d %X', time.localtime()),group_id_line))
        csv_sort(setting_crawer.EVENTS_PATH + account_line[1] + '.csv', '\t', 0)
        account_line = account_list.readline().replace('\n','').split(',')
