#!/usr/bin/python
# _*_ coding:utf-8 _*_
import sys

import math
import threading

import time

from config import define_attr
from config import setting_crawer
from mws import Amazon_Finance,Orders
import os
from publicfile.customizeClass import MyException
from publicfile.customizeFunction import get_data_to_save_db


class myThread (threading.Thread):   #继承父类threading.Thread
    def __init__(self, accounts):
        threading.Thread.__init__(self)
        self.accounts = accounts
        self.retry_num = 1

    def run(self):
        for account_line in self.accounts:
            account_line = account_line.replace('\n', '').split(',')
            if len(account_line) < 1:
                continue
            if define_attr.crawer_account and account_line[2] not in define_attr.crawer_account:
                continue
            elif account_line[2] in define_attr.no_crawer_account:
                continue
            amazon_api = Orders(access_key=account_line[2],
                                secret_key=account_line[3],
                                account_id=account_line[4],
                                mws_auth_token=account_line[6],
                                version='2013-09-01',
                                region=define_attr.region.get(account_line[5], 'US'),
                                mkplace_id=account_line[5],
                                )
            checkouOrdersFile(account_line[1])
            with open(setting_crawer.ORDER_PATH + account_line[1] + '.csv', 'r') as order_file:
                order_dict = {}
                order_list = []
                line_list = order_file.readline().split('\t')
                while len(line_list) > 1:
                    line_list = order_file.readline().replace('\n', '').split('\t')
                    if len(line_list) > 1:
                        order_dict[unicode(str(line_list[3]), "utf8")] = []
                        order_dict[unicode(str(line_list[3]), "utf8")].append(line_list[0])
                        order_dict[unicode(str(line_list[3]), "utf8")].append(line_list[1])
                        order_dict[unicode(str(line_list[3]), "utf8")].append(line_list[2])
                        order_dict[unicode(str(line_list[3]), "utf8")].append(line_list[3])
                        order_list.append(line_list[3])

            cycle_num = int(math.ceil(len(order_list) / 50.0))
            for num in range(0, cycle_num):
                self.retry_num = 1
                orders_detail_dict = {}
                while self.retry_num <= 3:
                    try:
                        print ('%s---->正在跑的,别着急  :  %d--->%d' % (account_line[1], (num + 1) * 50, len(order_list)))
                        orders_detail_dict = amazon_api.get_order(order_list[num * 50: (num + 1) * 50])
                        self.retry_num = 1
                        break
                    except Exception, e:
                        print('%s---->访问API异常,睡眠1分钟,正在重试第%d次  :  %s' % (account_line[1], self.retry_num, str(e)[0:100]))
                        self.retry_num += 1
                        time.sleep(61)
                if self.retry_num > 3:
                    with open(setting_crawer.API_LOG_PATH + account_line[1] + '.txt', 'a+') as log_write:
                        log_write.write('%20s : %d' % (time.strftime('%Y-%m-%d %X', time.localtime()), num))
                if not orders_detail_dict:
                    continue
                with open(setting_crawer.XML_ORDER_PATH + account_line[1] + '.xml','w') as xml_order_file:
                    xml_order_file.write(orders_detail_dict.response.content)
                amazon_orders = orders_detail_dict.parsed.get('Orders', {}).get('Order', [])
                amazon_orders = amazon_orders if isinstance(amazon_orders, list) else [amazon_orders]
                for amazon_orders_line in amazon_orders:
                    amazon_shipping_address = amazon_orders_line.get('ShippingAddress', {})
                    order_city = amazon_shipping_address.get('City', {}).get('value', '')
                    order_state = amazon_shipping_address.get('StateOrRegion', {}).get('value', '')
                    order_postal = amazon_shipping_address.get('PostalCode', {}).get('value', '')
                    amazon_order_status = order_status.get(
                        amazon_orders_line.get('FulfillmentChannel', '').get('value', ''), '')
                    amazon_order_id = amazon_orders_line.get('AmazonOrderId', '').get('value', '')

                    order_dict[str(amazon_order_id)].append(str(amazon_order_status))
                    order_dict[str(amazon_order_id)].append(order_city.encode('utf-8'))
                    order_dict[str(amazon_order_id)].append(order_state.encode('utf-8'))
                    order_dict[str(amazon_order_id)].append(order_postal.encode('utf-8'))


            with open(setting_crawer.ORDER_PATH + account_line[1] + '.csv', 'w') as order_file:
                order_file.write('\t'.join(setting_crawer.ORDER_CSV_FIELDS) + "\n")
                orsers_list = []
                for order_line in order_dict:
                    order_detail = '\t'.join(order_dict.get(order_line, []))
                    if order_detail not in orsers_list:
                        orsers_list.append(order_detail)
                order_file.write("\n".join(orsers_list))


order_status = {
    'AFN':'Amazon',
    'MFN':'Seller',
    '':''
}

def checkoutPath():

    if not os.path.exists(setting_crawer.ACCOUNT_PATH):
        raise MyException('你没有亚马逊用户信息哦！快去弄好,放在./config里面,并且命名为amazon_account.csv')


    if not os.path.exists(setting_crawer.EVENTS_PATH):
        raise MyException('你没有下载好财务信息哦！快去运行python finances_froupid.py')


    if not os.path.exists(setting_crawer.ORDER_PATH):
        os.mkdir(setting_crawer.ORDER_PATH)


def checkouOrdersFile(storename):
    if not os.path.exists(setting_crawer.ORDER_PATH + storename + '.csv'):
        with open(setting_crawer.ORDER_PATH + storename + '.csv', 'w') as check_file:
            check_file.write('\t'.join(setting_crawer.ORDER_CSV_FIELDS) + "\n")

try:
    checkoutPath()
except Exception,e:
    print e
    sys.exit()


with open(setting_crawer.ACCOUNT_PATH) as account_list:
    accounts = account_list.readlines()[1:]
    thread_list = []
    for thread_num in range(0,9):
        myThread(accounts[thread_num * 50:(thread_num + 1) * 50]).start()
