#!/usr/bin/python
# _*_ coding:utf-8 _*_
# encoding=utf8
import os
import shutil

from config import setting_crawer
from config import define_attr
import csv
order_status = {
    'AFN':'Amazon',
    'MFN':'Seller',
    '':''
}

def _TranToList(obj):
    if not isinstance(obj, list):
        return [obj]
    return obj

def get_data_to_save_db(fee_group_data,account_id, storename):
    fee_list = []
    order_id_list = []
    # order
    if fee_group_data['ShipmentEventList']:
        fee_order_list = _TranToList(fee_group_data['ShipmentEventList']['ShipmentEvent'])
        for fee_order in fee_order_list:
            fee_o_date = fee_order.get('PostedDate',{}).get('value','')
            fee_o_date = str(fee_o_date).replace('T', ' ').replace('Z', '')
            fee_o_marketplace = fee_order.get('MarketplaceName',{}).get('value','')
            fee_o_orderId = fee_order.get('AmazonOrderId',{}).get('value','')

            newdata = _TranToList(fee_order.get('ShipmentItemList',{}).get('ShipmentItem',{}))
            for fee_for_o_order in newdata:
                fee_o_sku = fee_for_o_order.get('SellerSKU',{}).get('value','')
                fee_o_quantity = fee_for_o_order.get('QuantityShipped',{}).get('value','')
                fee_order_dict = {}
                fee_order_list = fee_for_o_order.get('ItemChargeList',{}).get('ChargeComponent',[])
                fee_order_list = _TranToList(fee_order_list)
                for fee_line in fee_order_list:
                    if fee_line['ChargeType']['value'] in fee_order_dict:
                        fee_order_dict[fee_line['ChargeType']['value']] += float(fee_line['ChargeAmount']['CurrencyAmount']['value'])
                    else:
                        fee_order_dict[fee_line['ChargeType']['value']] = float(fee_line['ChargeAmount']['CurrencyAmount']['value'])

                fee_o_productSales = fee_order_dict.get('Principal',0.0)
                fee_o_salesTax = 0.0 # fee_order_dict.get('Principal',0.0)
                fee_o_shipping = fee_order_dict.get('ShippingCharge',0.0)
                fee_o_giftWrap = fee_order_dict.get('GiftWrap',0.0)

                fbafee_order_list = fee_for_o_order['ItemFeeList']['FeeComponent']
                fbafee_order_list = _TranToList(fbafee_order_list)
                fbafee_order_dict = {}

                for FeeComponent in fbafee_order_list:
                    if FeeComponent["FeeType"]['value'] in fbafee_order_dict:
                        fbafee_order_dict[FeeComponent["FeeType"]['value']] += float(FeeComponent['FeeAmount']['CurrencyAmount']['value'])
                    else:
                        fbafee_order_dict[FeeComponent["FeeType"]['value']] = float(FeeComponent['FeeAmount']['CurrencyAmount']['value'])

                fee_o_sellingFees = fbafee_order_dict.get('Commission',0.0) + fbafee_order_dict.get('ShippingHB',0.0)
                fee_o_fbaFees = fbafee_order_dict.get('FBAPerUnitFulfillmentFee',0.0) + fbafee_order_dict.get('FBAWeightBasedFee',0.0) + fbafee_order_dict.get('ShippingChargeback',0.0) + fbafee_order_dict.get('GiftwrapChargeback',0.0) + fbafee_order_dict.get('VariableClosingFee',0.0)

                fulfillment = ''

                fee_o_promotional = 0.0
                if 'PromotionList' in fee_for_o_order:
                    promotion_order_list = fee_for_o_order['PromotionList']['Promotion']
                    promotion_order_list = _TranToList(promotion_order_list)
                    promotion_order_dict = {}

                    for promotion in promotion_order_list:
                        if promotion['PromotionType']['value'] in promotion_order_dict:
                            promotion_order_dict[promotion['PromotionType']['value']] += float(promotion['PromotionAmount']['CurrencyAmount']['value'])
                        else:
                            promotion_order_dict[promotion['PromotionType']['value']] = float(promotion['PromotionAmount']['CurrencyAmount']['value'])

                    fee_o_promotional = promotion_order_dict.get('PromotionMetaDataDefinitionValue',0.0)

                fee_o_total =float(float(fee_o_promotional))+  float(fee_o_productSales)+ float(fee_o_salesTax)+ float(fee_o_shipping)+ float(fee_o_giftWrap)+ float(fee_o_sellingFees )+ float(fee_o_fbaFees)
                fee_order_dict = {'datetime':fee_o_date.replace(" ","T"), 'settlement': '', 'type': 'Order','account_id':str(account_id),
                                  'orderID': fee_o_orderId,
                                  'sku': fee_o_sku,
                                  'description': '', 'quantity': fee_o_quantity, 'marketplace': fee_o_marketplace,
                                  'fulfillment': fulfillment,
                                  'productSales': fee_o_productSales,
                                  'shippingCredits': fee_o_shipping, 'giftWrapCredits': fee_o_giftWrap,
                                  'promotionalRebates': fee_o_promotional,
                                  'salesTaxCollected': fee_o_salesTax, 'sellingFees': fee_o_sellingFees,
                                  'fbaFees': fee_o_fbaFees, 'otherTransactionFees': 0.0,
                                  'other': 0.0, 'total': float(fee_o_total), 'acount': '',
                                  'storename':storename
                                  }
                # if fee_order_dict['datetime'] < define_attr.starttime or fee_order_dict['datetime'] > define_attr.endtime:
                #     continue
                info_list = []
                for key in setting_crawer.EVENTS_CSV_FIELDS:
                    if key == 'sku':
                        info_list.append(fee_order_dict[key])
                    else:
                        info_list.append(str(fee_order_dict[key]))
                fee_list.append('\t'.join(info_list))

                info_list = []
                for key in setting_crawer.ORDER_CSV_FIELDS:
                    info_list.append(str(fee_order_dict.get(key,'')))
                order_id_list.append('\t'.join(info_list))

    if not define_attr.crawer_account:
        if fee_group_data['RefundEventList']:
            fee_order_list = _TranToList(fee_group_data['RefundEventList']['ShipmentEvent'])
            for fee_order in fee_order_list:
                fee_o_date = fee_order.get('PostedDate', {}).get('value', '')
                fee_o_date = str(fee_o_date).replace('T', ' ').replace('Z', '')
                fee_o_marketplace = fee_order.get('MarketplaceName', {}).get('value', '')
                fee_o_orderId = fee_order.get('AmazonOrderId', {}).get('value', '')

                newdata = _TranToList(fee_order['ShipmentItemAdjustmentList']['ShipmentItem'])
                for fee_for_o_order in newdata:
                    if isinstance(fee_for_o_order, str):
                        fee_for_o_order = fee_order.get('ShipmentItemAdjustmentList',{}).get('ShipmentItem',{})
                    # fee_o_orderId = fee_for_o_order['OrderItemId']
                    fee_o_sku = fee_for_o_order.get('SellerSKU',{}).get('value','')
                    fee_o_quantity = fee_for_o_order.get('QuantityShipped',{}).get('value','')
                    fee_order_list = fee_for_o_order.get('ItemChargeAdjustmentList',{}).get('ChargeComponent',[])
                    fee_order_list = _TranToList(fee_order_list)
                    fee_order_dict = {}
                    for fee_line in fee_order_list:
                        fee_order_dict[fee_line['ChargeType']['value']] = float(fee_line['ChargeAmount']['CurrencyAmount']['value'])

                    fee_o_productSales = fee_order_dict.get('Principal',0.0)
                    fee_o_salesTax = 0.0 # fee_dict.get('Principal',0.0)
                    fee_o_shipping = fee_order_dict.get('ShippingCharge',0.0)
                    fee_o_giftWrap = 0.0 # fee_dict.get('ShippingCharge',0.0)

                    fbafee_order_list = fee_for_o_order.get('ItemFeeAdjustmentList',{}).get('FeeComponent',[])
                    fbafee_order_list = _TranToList(fbafee_order_list)
                    fbafee_order_dict = {}

                    fee_o_sellingFees = 0.0
                    for FeeComponent in fbafee_order_list:
                        if FeeComponent['FeeType']['value'] in fbafee_order_dict:
                            fbafee_order_dict[FeeComponent['FeeType']['value']] += float(FeeComponent['FeeAmount']['CurrencyAmount']['value'])
                        else:
                            fbafee_order_dict[FeeComponent['FeeType']['value']] = float(FeeComponent['FeeAmount']['CurrencyAmount']['value'])

                    fee_o_sellingFees = fbafee_order_dict.get('Commission',0.0) + fbafee_order_dict.get('RefundCommission',0.0)
                    fee_o_fbaFees = fbafee_order_dict.get('ShippingChargeback',0.0)

                    fulfillment = ''

                    fee_o_promotional = 0.0
                    if 'PromotionAdjustmentList' in fee_for_o_order:
                        promotion_order_list = fee_for_o_order['PromotionAdjustmentList']['Promotion']
                        promotion_order_list = _TranToList(promotion_order_list)
                        promotion_order_dict = {}

                        for promotion in promotion_order_list:
                            if promotion['PromotionType']['value'] in promotion_order_dict:
                                promotion_order_dict[promotion['PromotionType']['value']] += float(promotion['PromotionAmount']['CurrencyAmount']['value'])
                            else:
                                promotion_order_dict[promotion['PromotionType']['value']] = float(promotion['PromotionAmount']['CurrencyAmount']['value'])

                        fee_o_promotional = promotion_order_dict['PromotionMetaDataDefinitionValue']

                    fee_o_total = float(float(fee_o_promotional)) + float(fee_o_productSales) + float(
                        fee_o_salesTax) + float(fee_o_shipping) + float(fee_o_giftWrap) + float(fee_o_sellingFees) + float(
                        fee_o_fbaFees)
                    fee_order_dict = {'datetime': fee_o_date.replace(" ","T"), 'settlement': '', 'type': 'Refund',
                                      'account_id': str(account_id),
                                      'orderID': fee_o_orderId,
                                      'sku': fee_o_sku,
                                      'description': '', 'quantity': fee_o_quantity, 'marketplace': fee_o_marketplace,
                                      'fulfillment': fulfillment,
                                      'productSales': fee_o_productSales,
                                      'shippingCredits': fee_o_shipping, 'giftWrapCredits': fee_o_giftWrap,
                                      'promotionalRebates': fee_o_promotional,
                                      'salesTaxCollected': fee_o_salesTax, 'sellingFees': fee_o_sellingFees,
                                      'fbaFees': fee_o_fbaFees, 'otherTransactionFees': 0.0,
                                      'other': 0.0, 'total': float(fee_o_total), 'acount': '',
                                      'storename':storename
                                      }
                    # if fee_order_dict['datetime'] < define_attr.starttime or fee_order_dict['datetime'] > define_attr.endtime:
                    #     continue
                    info_list = []
                    for key in setting_crawer.EVENTS_CSV_FIELDS:
                        if key == 'sku':
                            info_list.append(fee_order_dict[key])
                        else:
                            info_list.append(str(fee_order_dict[key]))
                    fee_list.append('\t'.join(info_list))

                    info_list = []
                    for key in setting_crawer.ORDER_CSV_FIELDS:
                        info_list.append(str(fee_order_dict.get(key,'')))
                    order_id_list.append('\t'.join(info_list))


    if not define_attr.crawer_account:
        if fee_group_data['GuaranteeClaimEventList']:
            fee_order_list = _TranToList(fee_group_data['RefundEventList']['ShipmentEvent'])
            for fee_order in fee_order_list:
                fee_o_date = fee_order.get('PostedDate', {}).get('value', '')
                fee_o_date = str(fee_o_date).replace('T', ' ').replace('Z', '')
                fee_o_marketplace = fee_order.get('MarketplaceName', {}).get('value', '')
                fee_o_orderId = fee_order.get('AmazonOrderId', {}).get('value', '')

                newdata = _TranToList(fee_order['ShipmentItemAdjustmentList']['ShipmentItem'])
                for fee_for_o_order in newdata:
                    if isinstance(fee_for_o_order, str):
                        fee_for_o_order = fee_order.get('ShipmentItemAdjustmentList',{}).get('ShipmentItem',{})
                    # fee_o_orderId = fee_for_o_order['OrderItemId']
                    fee_o_sku = fee_for_o_order.get('SellerSKU',{}).get('value','')
                    fee_o_quantity = fee_for_o_order.get('QuantityShipped',{}).get('value','')
                    fee_order_list = fee_for_o_order.get('ItemChargeAdjustmentList',{}).get('ChargeComponent',[])
                    fee_order_list = _TranToList(fee_order_list)
                    fee_order_dict = {}
                    for fee_line in fee_order_list:
                        fee_order_dict[fee_line['ChargeType']['value']] = float(fee_line['ChargeAmount']['CurrencyAmount']['value'])

                    fee_o_productSales = fee_order_dict.get('Principal',0.0)
                    fee_o_salesTax = 0.0 # fee_dict.get('Principal',0.0)
                    fee_o_shipping = fee_order_dict.get('ShippingCharge',0.0)
                    fee_o_giftWrap = 0.0 # fee_dict.get('ShippingCharge',0.0)

                    fbafee_order_list = fee_for_o_order.get('ItemFeeAdjustmentList',{}).get('FeeComponent',[])
                    fbafee_order_list = _TranToList(fbafee_order_list)
                    fbafee_order_dict = {}

                    fee_o_sellingFees = 0.0
                    for FeeComponent in fbafee_order_list:
                        if FeeComponent['FeeType']['value'] in fbafee_order_dict:
                            fbafee_order_dict[FeeComponent['FeeType']['value']] += float(FeeComponent['FeeAmount']['CurrencyAmount']['value'])
                        else:
                            fbafee_order_dict[FeeComponent['FeeType']['value']] = float(FeeComponent['FeeAmount']['CurrencyAmount']['value'])

                    fee_o_sellingFees = fbafee_order_dict.get('Commission',0.0) + fbafee_order_dict.get('RefundCommission',0.0)
                    fee_o_fbaFees = fbafee_order_dict.get('ShippingChargeback',0.0)

                    fulfillment = ''

                    fee_o_promotional = 0.0
                    if 'PromotionAdjustmentList' in fee_for_o_order:
                        promotion_order_list = fee_for_o_order['PromotionAdjustmentList']['Promotion']
                        promotion_order_list = _TranToList(promotion_order_list)
                        promotion_order_dict = {}

                        for promotion in promotion_order_list:
                            if promotion['PromotionType']['value'] in promotion_order_dict:
                                promotion_order_dict[promotion['PromotionType']['value']] += float(promotion['PromotionAmount']['CurrencyAmount']['value'])
                            else:
                                promotion_order_dict[promotion['PromotionType']['value']] = float(promotion['PromotionAmount']['CurrencyAmount']['value'])

                        fee_o_promotional = promotion_order_dict['PromotionMetaDataDefinitionValue']

                    fee_o_total = float(float(fee_o_promotional)) + float(fee_o_productSales) + float(
                        fee_o_salesTax) + float(fee_o_shipping) + float(fee_o_giftWrap) + float(fee_o_sellingFees) + float(
                        fee_o_fbaFees)
                    fee_order_dict = {'datetime': fee_o_date.replace(" ","T"), 'settlement': '', 'type': 'A-to-Z',
                                      'account_id': str(account_id),
                                      'orderID': fee_o_orderId,
                                      'sku': fee_o_sku,
                                      'description': '', 'quantity': fee_o_quantity, 'marketplace': fee_o_marketplace,
                                      'fulfillment': fulfillment,
                                      'productSales': fee_o_productSales,
                                      'shippingCredits': fee_o_shipping, 'giftWrapCredits': fee_o_giftWrap,
                                      'promotionalRebates': fee_o_promotional,
                                      'salesTaxCollected': fee_o_salesTax, 'sellingFees': fee_o_sellingFees,
                                      'fbaFees': fee_o_fbaFees, 'otherTransactionFees': 0.0,
                                      'other': 0.0, 'total': float(fee_o_total), 'acount': '',
                                      'storename':storename
                                      }
                    # if fee_order_dict['datetime'] < define_attr.starttime or fee_order_dict['datetime'] > define_attr.endtime:
                    #     continue
                    info_list = []
                    for key in setting_crawer.EVENTS_CSV_FIELDS:
                        if key == 'sku':
                            info_list.append(fee_order_dict[key])
                        else:
                            info_list.append(str(fee_order_dict[key]))
                    fee_list.append('\t'.join(info_list))

                    info_list = []
                    for key in setting_crawer.ORDER_CSV_FIELDS:
                        info_list.append(str(fee_order_dict.get(key,'')))
                    order_id_list.append('\t'.join(info_list))

    return_info = {
        'order_id_info' : list(set(order_id_list)),
        'fee_info' : list(set(fee_list)),
    }

    return return_info


# 对csv文件内容进行排序
def csv_sort(file_path, delimiter, sort_field_index, first_line_sort = False):
    data = csv.reader(open
                      (file_path), delimiter=delimiter)
    data_list = []
    # 根据用户选择,对第一行进行处理
    define_fields = None
    if first_line_sort:
        for row_line in data:
            data_list.append(row_line)
    else:
        first_now = True
        for row_line in data:
            if first_now:
                define_fields = row_line
                first_now = False
            else:
                data_list.append(row_line)

    sortedlist = sorted(data_list, key=lambda x: (x[sort_field_index]))

    with open(file_path, "wb") as f:
        fileWriter = csv.writer(f, delimiter=delimiter)
        # fileWriter.writerow(define_fields)
        if define_fields:
            fileWriter.writerow(define_fields)
        for row_line in sortedlist:
            fileWriter.writerow(row_line)

    f.close()


#清空结果文件夹
def empty_result():
    if os.path.exists(setting_crawer.RESULT_PATH):
        shutil.rmtree(setting_crawer.RESULT_PATH)
        os.mkdir(setting_crawer.RESULT_PATH)